package App::SCS::Plugin::Archives;

use Moo;
no warnings::illegalproto;

with 'App::SCS::Role::Plugin';

sub page_plugins {
  Archive => 'App::SCS::Plugin::Archive::PagePlugin'
}

sub page_dispatchers {
  my ($self) = @_;
  sub (/**:path/old/:page) {
    return unless $_{page} =~ /^\d+$/;
    if (my $page = $self->pages->get({ path => $_{path} })) {
      if ($page->has_plugin_config('Archive')) {
        return $page->with(path => $_{path})
                    ->with_plugin_config(Archive => { page => $_{page} });
      }
    }
    return;
  }
}

1;
